function paper_Plot_LRBFGS_p0()

    load('Paper_LRBFGS_p0_FSGSTSKS_64_64.mat');
%     load('Paper_LRBFGS_p0_FSGSTSKS_128_128.mat');

    h1 = figure(1);
    set(h1, 'Position', [21, 201, 1000, 300]);clf
    set(0,'defaultaxesfontsize',12, ...
       'defaultaxeslinewidth',0.7, ...
       'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
    set(0,'defaultlinemarkersize',10)
    colors = ['b', 'r', 'k', 'm', 'g', 'c', 'y'];
    marks = ['v', 'o', '*', '+', '^', 'x', '>', '<'];
    lines{1} = '--'; lines{2} = '-.'; lines{3} = ':'; lines{4} = '-';
    n = 4;
    for i = 1 : n
        ks = KS{i};
        ks(end + 1 : n) = 1;
        l = length(FS{i});
        R{1, i} = ks(1) : l;
        for j = 2 : n
            R{j, i} = ks(j) : ks(j - 1) - 1;
        end
    end
    
    subplot(1, 2, 1);
    for i = 1 : n
        fs = FS{i};
        semilogy(R{1, i}, fs(R{1, i}), ['-' colors(i)]);
        hold on
    end
    ylabel('f(x)')
    xlabel('iter')
    ylim([1e-12, 1]);
    title('Iteration Number versus Function Values: n_1 = n_2 = 64');
%     title('Iteration Number versus Function Values: n_1 = n_2 = 128');
    legend('p_0:1', 'p_0:2', 'p_0:4', 'p_0:8');
    for i = 1 : n
        fs = FS{i};
        for j = 2 : n
            semilogy(R{j, i}, fs(R{j, i}), ['-' colors(i)]);
            hold on
        end
    end
    for i = 1 : n
        fs = FS{i};
        for j = 1 : n
            x = R{j, i};
            y = fs(R{j, i});
            semilogy(x(1 : 10 : end), y(1 : 10 : end), [marks(j), colors(i)], 'MarkerSize', 6);
            hold on
        end
    end
    
    subplot(1, 2, 2);
    for i = 1 : n
        fs = FS{i};
        ts = TS{i};
        semilogy(ts(R{1, i}), fs(R{1, i}), ['-' colors(i)]);
        hold on
    end
    ylabel('f(x)')
    xlabel('time')
    ylim([1e-12, 1]);
    title('Computation Time versus Function Values: n_1 = n_2 = 64');
%     title('Computation Time versus Function Values: n_1 = n_2 = 128');
    legend('p_0:1', 'p_0:2', 'p_0:4', 'p_0:8');
    for i = 1 : n
        fs = FS{i};
        ts = TS{i};
        for j = 2 : n
            semilogy(ts(R{j, i}), fs(R{j, i}), ['-' colors(i)]);
            hold on
        end
    end
    for i = 1 : n
        fs = FS{i};
        ts = TS{i};
        for j = 1 : n
            x = ts(R{j, i});
            y = fs(R{j, i});
            semilogy(x(1 : 10 : end), y(1 : 10 : end), [marks(j), colors(i)], 'MarkerSize', 6);
            hold on
        end
    end
    
%     lines{1} = '--'; lines{2} = '-.'; lines{3} = ':'; lines{4} = '-';
% %     subplot(1, 2, 1)
%     for i = 1 : size(GXCLRBFGS, 1)
%         plot(GXCLRBFGS(i, :), GYCLRBFGS(i, :), [lines{i} '+' colors(i)]);
%         hold on
%     end
%     for i = 1 : size(GXCFISTA, 1)
%         plot(GXCFISTA(i, :), GYCFISTA(i, :), [lines{i} 'o' colors(i)]);
%         hold on
%     end
%     xlabel('SNR in dB')
%     ylabel('RMSE in dB')
%     title('Comparison of LRBFGS and LR-FISTA');
%     legend('LRBFGS l:6', 'LRBFGS l:8', 'LRBFGS l:10', ...
%         'LR-FISTA l:6', 'LR-FISTA l:8', 'LR-FISTA l:10');%, 'NorthEast');
% 
%     saveas(h1, 'Paper_SNR_MSE_Gaussian', 'fig');
end
