function paper_PlotSNR_MSE_Gaussian_masks()

GXCLRBFGS = load('GXCLRBFGS_kappa_0');
GYCLRBFGS = load('GYCLRBFGS_kappa_0');
GXCFISTA = load('GXCFISTA_kappa_0');
GYCFISTA = load('GYCFISTA_kappa_0');

    h1 = figure('Position', [1, 1, 540, 360]);clf
    set(0,'defaultaxesfontsize',10, ...
       'defaultaxeslinewidth',0.7, ...
       'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
    set(0,'defaultlinemarkersize',10)
    colors = ['b', 'r', 'k', 'm', 'g', 'c', 'y'];
    marks = ['+', 'o', '*'];
    lines{1} = '--'; lines{2} = '-.'; lines{3} = ':'; lines{4} = '-';
%     subplot(1, 2, 1)
    for i = 1 : size(GXCLRBFGS, 1)
        plot(GXCLRBFGS(i, :), GYCLRBFGS(i, :), [lines{i} '+' colors(i)]);
        hold on
    end
    for i = 1 : size(GXCFISTA, 1)
        plot(GXCFISTA(i, :), GYCFISTA(i, :), [lines{i} 'o' colors(i)]);
        hold on
    end
    xlabel('SNR in dB')
    ylabel('RMSE in dB')
    title('Comparison of Algorithm 2 and LR-FISTA');
    legend('Algorithm 2 l:6', 'Algorithm 2 l:8', 'Algorithm 2 l:10', ...
        'LR-FISTA l:6', 'LR-FISTA l:8', 'LR-FISTA l:10');%, 'NorthEast');

    saveas(h1, 'Paper_SNR_MSE_Gaussian', 'fig');
end
