function paper_SNR_MSE_Gaussian_masks(kappa)

    ls = [6, 8, 10];
    ratio = 0.2;
    taus = [1e-4, 1e-4 * ratio, 1e-4 * ratio^2, 1e-4 * ratio^3, 1e-4 * ratio^4] * 5;
    n1 = 64;
    n2 = 64;
    err = 1e-6;
%     err = 1e-8;
%     kappa = 1e-6;
    
    for i = 1 : length(ls)
        for j = 1 : length(taus)
            [X, F, G, T, timecost, nf, ng, nR, nH, nV, nVp, ave_time, mse, snr] = test_PhaseRetrieval(ls(i), taus(j), 1, n1, n2, kappa, err); %Gaussian
            GXCLRBFGS(i, j) = snr;
            GYCLRBFGS(i, j) = 10 * log(mse) / log(10);
        end
    end
    GXCFISTA = [];
    GYCFISTA = [];
    for i = 1 : length(ls)
        for j = 1 : length(taus)
            [iter, nf, ng, f_final, mse, ave_time, snr] = test_TFOCS_PhaseRetrieval(ls(i), taus(j), 1, n1, n2, kappa, err); %Gaussian
            GXCFISTA(i, j) = snr;
            GYCFISTA(i, j) = 10 * log(mse) / log(10);
        end
    end
    

%     for i = 1 : length(ls)
%         for j = 1 : length(taus)
%             [X, F, G, T, timecost, nf, ng, nR, nH, nV, nVp, ave_time, mse, snr] = test_PhaseRetrieval(ls(i), taus(j), 0, n1, n2) %0/1
%             MXCLRBFGS(i, j) = snr;
%             MYCLRBFGS(i, j) = 10 * log(mse) / log(10);
%         end
%     end
%     for i = 1 : length(ls)
%         for j = 1 : length(taus)
%             [iter, nf, ng, f_final, mse, ave_time, snr] = test_TFOCS_PhaseRetrieval(ls(i), taus(j), 0, n1, n2); %0/1
%             MXCFISTA(i, j) = snr;
%             MYCFISTA(i, j) = 10 * log(mse) / log(10);
%         end
%     end
    
GXCLRBFGS
GYCLRBFGS
GXCFISTA
GYCFISTA
dlmwrite(['GXCLRBFGS_kappa_' num2str(kappa)], GXCLRBFGS);
dlmwrite(['GYCLRBFGS_kappa_' num2str(kappa)], GYCLRBFGS);
dlmwrite(['GXCFISTA_kappa_' num2str(kappa)], GXCFISTA);
dlmwrite(['GYCFISTA_kappa_' num2str(kappa)], GYCFISTA);

%     h1 = figure('Position', [1, 1, 480, 360]);clf
%     set(0,'defaultaxesfontsize',10, ...
%        'defaultaxeslinewidth',0.7, ...
%        'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
%     set(0,'defaultlinemarkersize',10)
%     colors = ['k', 'r', 'b', 'm', 'g', 'c', 'y'];
%     marks = ['+', 'o', '*'];
%     lines = ['-', '--', '-.'];
% %     subplot(1, 2, 1)
%     for i = 1 : length(ls)
%         plot(GXCLRBFGS(i, :), GYCLRBFGS(i, :), ['-' marks(i) colors(i)]);
%         hold on
%     end
%     for i = 1 : length(ls)
%         plot(GXCFISTA(i, :), GYCFISTA(i, :), ['-.' marks(i) colors(i)]);
%         hold on
%     end
%     xlabel('SNR')
%     ylabel('RMSE in dB')
%     title('Comparison of LRBFGS and LR-FISTA');
%     legend(['LRBFGS l:' num2str(ls(1))], ['LRBFGS l:' num2str(ls(2))], ['LRBFGS l:' num2str(ls(3))], ...
%         ['FISTA l:' num2str(ls(1))], ['FISTA l:' num2str(ls(1))], ['FISTA l:' num2str(ls(1))], 'NorthEast');
% 
%     saveas(h1, 'Paper_SNR_MSE_Gaussian', 'fig');
end

function str = outputfloat(x)
    if(x <= 0)
        str = '';
        return;
    end
    p = log(x)/log(10);
    p = - ceil(-p);
    x = round(x * 10^(-p) * 100);
    x = x / 100;
    strx = sprintf('%3.2f', x);
    if(p ~= 0)
        str = [strx '_{' num2str(p) '}'];
    else
        str = strx;
    end
end

function [X, F, G, T, timecost, nf, ng, nR, nH, nV, nVp, ave_time, mse, snr] = test_PhaseRetrieval(l, tau, isgaussian, n1, n2, kappa, scerr)
% test file for test_PhaseRetrieval.
% 
% By Wen Huang
    fprintf('test for Phase Retrieval problem. \n');
    r = 1;
%     r = 943
    rand('state', r);
    randn('state', r);
%     n1 = 16;
%     n2 = 16;
    global count
    count = 0;
    n = n1 * n2;
%     l = 6;
    m = l * n;
    k = 8;
    method = 3;
    
    fprintf('In this case, n1 = %d, n2 = %d, n = %d, l = %d. b, and x0 are chosen randomly. Random seed is %d \n', n1, n2, n, l, r);
    
    metric = 1;

    %% generate masks and a true solution.
    global iscomplex
    iscomplex = 1;
    global isfixedrank
    isfixedrank = 0;
    masks = complex(randn(n1, n2, l), iscomplex * randn(n1, n2, l));
    phase = complex(randn(n1, n2), iscomplex * randn(n1, n2));
    phase = phase / norm(phase);
    b = zeros(m, 1);
    btrue = zeros(m, 1);
    for i = 1 : l
        zi = reshape(fft2(phase .* masks(:, :, i)) / sqrt(n1 * n2), [], 1);
        btrue((i - 1) * n + 1 : i * n) = conj(zi) .* zi;
        b((i - 1) * n + 1 : i * n) = conj(zi) .* zi + tau * randn(n, 1);
    end
    snr = 10 * log(norm(btrue) / norm(btrue - b)) / log(10)
%     bnorm = norm(b)
%     phasenorm = norm(phase, 'fro')
    
    %%
    initialtype = 0; % 0: random, 1: true solution, 2: modification of true solution
    x0eps = 0.1;
    if((initialtype == 1 || initialtype == 2) && k ~= 1)
        fprintf('k should be 1\n');
        return;
    end
    
    if(initialtype == 0)
        [x1.U, r] = qr(complex(randn(n, k), iscomplex * randn(n, k)), 0);
%         x1.D = spdiags(rand(k, 1), 0, k, k);
        x1.D = spdiags(ones(k, 1), 0, k, k);
    elseif(initialtype == 1)
        x1.U = reshape(phase, [], 1) / norm(reshape(phase, [], 1));
        x1.D = norm(reshape(phase, [], 1))^2;
    elseif(initialtype == 2)
        temp = phase + randn(n1, n2) * x0eps;
        x1.U = reshape(temp, [], 1) / norm(reshape(temp, [], 1));
        x1.D = norm(reshape(temp, [], 1))^2;
    end
    
    if(metric == 1 || metric == 2)
        x1.U = full(x1.U * sqrt(x1.D));
        if(method == 2 || method == 5)
            params.H0 = eye(n * k);
            params.B0 = eye(n * k);
        end
    end
    
    params.x0 = x1;
    params.error = scerr;
    params.max_t = inf;
    params.debug = 0;
    params.manifold = 2;
    params.m = 4;
    params.alpha = 1e-4;
    params.beta = 0.999;
    params.min_Delta = 1e-8;
    params.minstepsize = eps;
    params.maxstepsize = 200;
%     params.kappa = 0.9;
%     params.retraction = Retraction;
%     params.vector_transport = VT;
    params.Delta_bar = inf;
    params.Delta0 = 1;
    params.StopCriterion = 0;
    params.restart = 0;
    if(method == 11)
        params.linesearch = 1;
    end
    times = 0;
    total_timecost = 0;
    while(total_timecost < 60 && times < 1)
        fprintf('%d: ', times);
        [X, F, G, T1, timecost, nf, ng, nR, nH, nV, nVp] = driver_PhaseRetrieval(b, masks, method, params, phase, metric, 0.9, 0, kappa);
        if(times == 0)
            T = T1;
        else
            T = T + T1;
        end
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end
    if(method == 13)
        return;
    end
    mse = MSE_error(X{end}.U, reshape(phase, [], 1));
    T = T / times;
    ave_time = total_timecost / times;
    fprintf('average time cost of %d times is %f. \n', times, total_timecost / times);
end

function mse = MSE_error(x, phase)
    X1 = [real(x), imag(x)];
    X2 = [real(phase), imag(phase)];
    [U, S, V] = svd(X2'*X1);
    O = V * U';
    mse = norm(X1 * O - X2, 'fro') / norm(X2, 'fro');
end

function [iter, nf, ng, f_final, mse, ave_time, snr] = test_TFOCS_PhaseRetrieval(l, tau, isgaussian, n1, n2, kappa, scerr)
%% Now, add in constraints
    r = rand();
%     r = floor(r * 10000)
    r = 1;
    rand('state', r);
    randn('state', r);
%     n1 = 16;
%     n2 = 16;
    n = n1 * n2;
%     l = 6;
    m = l * n;
    k = 1;

    %% generate masks and a true solution.
    global iscomplex
    iscomplex = 1;
    masks = complex(randn(n1, n2, l), iscomplex * randn(n1, n2, l));
    phase = complex(randn(n1, n2), iscomplex * randn(n1, n2));
    phase = phase / norm(phase);
    b = zeros(m, 1);
    btrue = zeros(m, 1);
    for i = 1 : l
        zi = reshape(fft2(phase .* masks(:, :, i)) / sqrt(n1 * n2), [], 1);
        btrue((i - 1) * n + 1 : i * n) = conj(zi) .* zi;
        b((i - 1) * n + 1 : i * n) = conj(zi) .* zi + tau * randn(n, 1);
    end
    snr = 10 * log(norm(btrue) / norm(btrue - b)) / log(10)
%     bnorm = norm(b)
%     phasenorm = norm(phase, 'fro')
    
    initialtype = 0; % 0: random, 1: true solution, 2: modification of true solution
    x0eps = 0.1;
    if((initialtype == 1 || initialtype == 2) && k ~= 1)
        fprintf('k should be 1\n');
        return;
    end
    
    if(initialtype == 0)
        [x1.U, r] = qr(complex(randn(n, k), iscomplex * randn(n, k)), 0);
%         x1.D = spdiags(rand(k, 1), 0, k, k);
        x1.D = spdiags(ones(k, 1), 0, k, k);
    elseif(initialtype == 1)
        x1.U = reshape(phase, [], 1) / norm(reshape(phase, [], 1));
        x1.D = norm(reshape(phase, [], 1))^2;
    elseif(initialtype == 2)
        temp = phase + randn(n1, n2) * x0eps;
        x1.U = reshape(temp, [], 1) / norm(reshape(temp, [], 1));
        x1.D = norm(reshape(temp, [], 1))^2;
    end
    x0 = full(x1.U * sqrt(x1.D));

    smoothF = @(x)f_gf(x, masks, b, kappa);
    
    opts = [];
    opts.tol        = scerr;
    opts.maxits     = 2000;
    opts.alg = 'N83_PR';
%     opts.stopCrit = 2;
%     opts.stopFcn = @stopFcn;
%     opts.err = 1e-6;
    
    times = 0;
    total_timecost = 0;
    while(total_timecost < 60 && times < 1)
        fprintf('times:%d, initial p:%d \n', times, k);
        [ x, out, optsOut ] = tfocs(smoothF, [], [], x0, opts );
        timecost = optsOut.timecost;
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end
    ave_time = total_timecost / times;
    iter = optsOut.iter;
    nf = optsOut.nf;
    ng = optsOut.ng;
    f_final = f_gf(x(:, 1), masks, b, 0);
    mse = MSE_error(x(:, 1), reshape(phase, [], 1));
return;
end

function stop = stopFcn(f, x)
    stop = 0;% f < 1e-10;
return;
end

function [f, gf] = f_gf(x, masks, b, kappa)
    [n1, n2, l] = size(masks);
    n = n1 * n2;
    k = size(x, 2);
    m = l * n;
    D = zeros(m, 1);
    ZY = zeros(m, k);
    for i = 1 : l
        sZqi = zeros(n, 1);
        for j = 1 : k
            temp = reshape(fft2(reshape(x(:, j), n1, n2) / sqrt(n1 * n2) .* masks(:, :, i)), [], 1);
            ZY((i - 1) * n + 1 : i * n, j) = reshape(temp, [], 1);
            sZqi = sZqi + conj(temp) .* temp;
        end
        D((i - 1) * n + 1 : i * n) = reshape(sZqi, [], 1) - b((i - 1) * n + 1 : i * n);
    end
    f = norm(D)^2 / norm(b, 'fro')^2;
    f = f + kappa * norm(x, 'fro')^2;%% add penelty term
    gf = @(v)gfv(v, D, masks, b, kappa);
return
end

function output = gfv(v, D, masks, b, kappa)
    [n1, n2, l] = size(masks);
    n = n1 * n2;
    s = size(v, 2);
    m = length(D);
    Zv = zeros(m, s);    
    for i = 1 : l
        for j = 1 : s
            temp = reshape(fft2(reshape(v(:, j), n1, n2) / sqrt(n1 * n2) .* masks(:, :, i)), [], 1);
            Zv((i - 1) * n + 1 : i * n, j) = reshape(temp, [], 1);
        end
    end
    
    DZv = spdiags(D, 0, m, m) * Zv;
    %% Z^H *DZv
    Y = zeros(n, s);
    for i = 1 : l
        temp = zeros(n, s);
        for j = 1 : s
            temp(:, j) = reshape(ifft2(reshape(DZv((i - 1) * n + 1 : i * n, j) * sqrt(n1 * n2), n1, n2)), [], 1);
        end
        temp = conj(spdiags(reshape(masks(:, :, i), [], 1), 0, n, n)) * temp;
        Y = Y + temp;
    end
    output = 2 * Y / norm(b, 'fro')^2 + kappa * v;
return
end

