function [T, G] = test_PhaseRetrieval%(mask, b_exact, xtrue, xinitial)
% test file for test_PhaseRetrieval.
% 
% By Wen Huang
    fprintf('test for Phase Retrieval problem. \n');
    r = rand();
    r = floor(r * 10000)
    r = 3
%     r = 943
    rand('state', r);
    randn('state', r);
    n1 = 64;
    n2 = 64;
    global count
    count = 0;
    n = n1 * n2;
    l = 6;
    m = l * n;
    k = 4;
    
    fprintf('In this case, n1 = %d, n2 = %d, n = %d, l = %d. b, and x0 are chosen randomly. Random seed is %d \n', n1, n2, n, l, r);
    
    fprintf('which metric do you want to test: \n');
    fprintf('1, quotient \n');
    fprintf('2, right invariant \n');
    fprintf('otherwise, break \n');
    metric = input('please input: ');
    if(metric < 1 || metric > 2)
        fprintf('exit! \n');
        return;
    end
    
    fprintf('which algorithm do you want to test: \n');
    fprintf('3, LRBFGS \n');
    fprintf('4, RSD \n');
    fprintf('6, LRTR-SR1 \n');
    fprintf('7, RTR-SD \n');
    fprintf('9, RTR-Newton \n');
    fprintf('11, RCG \n');
    fprintf('12, RNewton \n');
    fprintf('13, check grad Hess \n');
    fprintf('otherwise, break \n');
    method = input('please input: ');
    if(method < 1 || method > 13)
        fprintf('exit! \n');
        return;
    end
    
    %% generate masks and a true solution.
    global iscomplex
    iscomplex = 1;
    global isfixedrank
    isfixedrank = 0;
    masks = complex(randn(n1, n2, l), iscomplex * randn(n1, n2, l));
    phase = complex(randn(n1, n2), iscomplex * randn(n1, n2));
    phase = phase / norm(phase);
    b = zeros(m, 1);
    for i = 1 : l
        zi = reshape(fft2(phase .* masks(:, :, i)) / sqrt(n1 * n2), [], 1);
        b((i - 1) * n + 1 : i * n) = conj(zi) .* zi;
    end
    bnorm = norm(b)
    phasenorm = norm(phase, 'fro')
    
    %%
    initialtype = 0; % 0: random, 1: true solution, 2: modification of true solution
    x0eps = 0.1;
    if((initialtype == 1 || initialtype == 2) && k ~= 1)
        fprintf('k should be 1\n');
        return;
    end
    
    if(initialtype == 0)
        [x1.U, r] = qr(complex(randn(n, k), iscomplex * randn(n, k)), 0);
%         x1.D = spdiags(rand(k, 1), 0, k, k);
        x1.D = spdiags(ones(k, 1), 0, k, k);
    elseif(initialtype == 1)
        x1.U = reshape(phase, [], 1) / norm(reshape(phase, [], 1));
        x1.D = norm(reshape(phase, [], 1))^2;
    elseif(initialtype == 2)
        temp = phase + randn(n1, n2) * x0eps;
        x1.U = reshape(temp, [], 1) / norm(reshape(temp, [], 1));
        x1.D = norm(reshape(temp, [], 1))^2;
    end
    
    if(metric == 1 || metric == 2)
        x1.U = full(x1.U * sqrt(x1.D));
        if(method == 2 || method == 5)
            params.H0 = eye(n * k);
            params.B0 = eye(n * k);
        end
    end
    
    params.x0 = x1;
    params.error = 1e-6;
    params.max_t = 1000;
    params.debug = 1;
    params.manifold = 2;
    params.m = 4;
    params.alpha = 1e-4;
    params.beta = 0.999;
    params.min_Delta = 1e-8;
    params.minstepsize = eps;
    params.maxstepsize = 200;
%     params.kappa = 0.9;
%     params.retraction = Retraction;
%     params.vector_transport = VT;
    params.Delta_bar = inf;
    params.Delta0 = 1;
    params.StopCriterion = 0;
    params.restart = 0;
    if(method == 11)
        params.linesearch = 3;
        params.beta = 0.1;
        params.initstepsize = 1;
    end
    delta = 0.9;
    times = 0;
    total_timecost = 0;
    while(total_timecost < 60 && times < 1)
        fprintf('%d: ', times);
        % Choose one of the drivers
        % The vector transport defined in the following driver is not isometric.
        [X, F, G, T, timecost, nf, ng, nR, nH, nV, nVp] = driver_PhaseRetrieval_faster(b, masks, method, params, phase, metric, delta, 1, 0);
        % The vector transport defined in the following driver is isometric.
        %[X, F, G, T, timecost, nf, ng, nR, nH, nV, nVp] = driver_PhaseRetrieval(b, masks, method, params, phase, metric, delta, 1, 0);
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end
    if(method == 13)
        return;
    end
    
    xend = X{end}.U;
    normsolu = norm(xend)
    if(metric == 1 || metric == 2)
        [U, S, V] = svd(xend,0);
%         S
%         norm(phase, 'fro')
        vp = reshape(phase, [], 1);
        ve = U(:, 1) * S(1, 1);
%         norm(vp - ve * vp(1, 1) / ve(1, 1))
%         vp(1, 1) / ve(1, 1)
% %         norm(vp * vp' - ve * ve')
    end
    
%     Qend = xend{1};
%     Sigmaend = xend{2}
%     norm(reshape(phase, [], 1) * reshape(phase, [], 1)' - Qend(:, 1) * (Sigmaend(1,1)) * Qend(:, 1)')
    fprintf('average time cost of %d times is %f. \n', times, total_timecost / times);
end
